<html>
<head>
<title>OgreDynLib.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreDynLib.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreDynLib_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _DynLib_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _DynLib_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_HANDLE hInstance</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_LOAD( a ) LoadLibraryEx( a, NULL, LOAD_WITH_ALTERED_SEARCH_PATH )</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_GETSYM( a, b ) GetProcAddress( a, b )</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_UNLOAD( a ) !FreeLibrary( a )</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="keyword">struct </span>HINSTANCE__;
<a name="l00040"></a>00040 <span class="keyword">typedef</span> <span class="keyword">struct </span>HINSTANCE__* hInstance;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_LINUX || OGRE_PLATFORM == OGRE_PLATFORM_ANDROID</span>
<a name="l00043"></a><a class="code" href="OgreDynLib_8h.html#a72233679ad2f01755e375b6fcbf8cfdb">00043</a> <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_HANDLE void*</span>
<a name="l00044"></a><a class="code" href="OgreDynLib_8h.html#a134d80db854047b000a6a3d5dc023bcc">00044</a> <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_LOAD( a ) dlopen( a, RTLD_LAZY | RTLD_GLOBAL)</span>
<a name="l00045"></a><a class="code" href="OgreDynLib_8h.html#a611f8319ce7e78bfb274017c2b53a81b">00045</a> <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_GETSYM( a, b ) dlsym( a, b )</span>
<a name="l00046"></a><a class="code" href="OgreDynLib_8h.html#aea4c10bca1e97e459d97b4c9b7aee51a">00046</a> <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_UNLOAD( a ) dlclose( a )</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>
<a name="l00048"></a>00048 <span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_APPLE || OGRE_PLATFORM == OGRE_PLATFORM_APPLE_IOS</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_HANDLE void*</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_LOAD( a ) mac_loadDylib( a )</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_GETSYM( a, b ) dlsym( a, b )</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_UNLOAD( a ) dlclose( a )</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>
<a name="l00054"></a>00054 <span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_SYMBIAN || OGRE_PLATFORM == OGRE_PLATFORM_NACL</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_HANDLE void*</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_LOAD( a ) 0</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_GETSYM( a, b ) 0</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span><span class="preprocessor">#    define DYNLIB_UNLOAD( a ) 0</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>
<a name="l00060"></a>00060 <span class="preprocessor">#endif</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>
<a name="l00062"></a>00062 <span class="keyword">namespace </span>Ogre {
<a name="l00081"></a><a class="code" href="classOgre_1_1DynLib.html">00081</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DynLib.html" title="Resource holding data about a dynamic library.">DynLib</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">DynLibAlloc</a>
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083     <span class="keyword">protected</span>:
<a name="l00084"></a><a class="code" href="classOgre_1_1DynLib.html#af96984b5e5e1d1fcf0cc9966bba7d898">00084</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1DynLib.html#af96984b5e5e1d1fcf0cc9966bba7d898">mName</a>;
<a name="l00086"></a>00086         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> dynlibError(<span class="keywordtype">void</span>);
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00092"></a>00092         <a class="code" href="classOgre_1_1DynLib.html" title="Resource holding data about a dynamic library.">DynLib</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name );
<a name="l00093"></a>00093 
<a name="l00096"></a>00096         ~<a class="code" href="classOgre_1_1DynLib.html" title="Resource holding data about a dynamic library.">DynLib</a>();
<a name="l00097"></a>00097 
<a name="l00100"></a>00100         <span class="keywordtype">void</span> load();
<a name="l00103"></a>00103         <span class="keywordtype">void</span> unload();
<a name="l00105"></a><a class="code" href="classOgre_1_1DynLib.html#a69bd2a1b70ccba92339d7c54b1ad8f4f">00105</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1DynLib.html#a69bd2a1b70ccba92339d7c54b1ad8f4f" title="Get the name of the library.">getName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00106"></a>00106 
<a name="l00118"></a>00118         <span class="keywordtype">void</span>* getSymbol( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; strName ) <span class="keyword">const</span> <span class="keywordflow">throw</span>();
<a name="l00119"></a>00119 
<a name="l00120"></a>00120     <span class="keyword">protected</span>:
<a name="l00121"></a>00121 
<a name="l00123"></a><a class="code" href="classOgre_1_1DynLib.html#a5303a358bbb6b3829d090012b3077888">00123</a>         <a class="code" href="OgreDynLib_8h.html#a72233679ad2f01755e375b6fcbf8cfdb">DYNLIB_HANDLE</a> <a class="code" href="classOgre_1_1DynLib.html#a5303a358bbb6b3829d090012b3077888" title="Handle to the loaded library.">mInst</a>;
<a name="l00124"></a>00124     };
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
